
% -*-Prolog-*-  
:- use_module(library(lists)).

not(P) :- \+ P.

addUp(ListOfNumbers, Total) :-
	addUp(ListOfNumbers, 0, Total).
addUp([ ], Total, Total).
addUp([Numb | Rest], InTotal, OutTotal) :-
     NewInTotal is InTotal + Numb,
     addUp(Rest, NewInTotal, OutTotal).

strictMember(X, [Y | _]) :-
	X == Y,
	!.
strictMember(X, [_ | Ys]) :-
	strictMember(X, Ys).

subsetOf([], _).
subsetOf([X | Rest], Ys) :-
	member(X, Ys),
	subsetOf(Rest, Ys).

strictSubsetOf([ ], _).
strictSubsetOf([X | Rest], Ys) :-
	strictMember(X, Ys),
	strictSubsetOf(Rest, Ys),
	!.

/* subsetOfElement(SubSet, ListOfSets) -
   true if SubSet is an ord_subset of one of the elements of ListOfSets
*/
subsetOfElement(SubSet, [Set | Rest]) :-
	(ord_subset(SubSet, Set) ->
	    true
	;
	    subsetOfElement(SubSet, Rest)).


stringPrint(ListOfCodes) :-
	/* SWI prolog has internal strings that are different from
	the normal prolog's representation of strings as lists of
	code, and its format predicate's handling of '~s' does not
	handle the latter, so we tranform the list of codes into
	SWI's  internal representation and then print it out
	*/
	string_to_list(String, ListOfCodes),
	format('~s',String).