
/*
counter predicates
====================

examples of use:
- To create a counter (with an initial value of 0)
initialiseCounter(openList)

- To increment (add 1 to) a counter
    (if counter doesn't exist then create it)
incrementCounter(openList)

- to increase (add n to) a counter
increaseCounter(Counter, Amount)

- To decrement (subtract 1 from) a counter
    (if count becomes 0 then counter is removed)
decrementCounter(openList)

- To access the current value of a counter
counter(openList, Value)

*/

removeCounter(Counter) :-
	retractall(counter(Counter, _)).

initialiseCounter(Counter) :-
	removeCounter(Counter),
	assert(counter(Counter, 0)).

incrementCounter(Counter) :-
	(retract(counter(Counter, N))
	->
	    NewCount is N + 1,
	    assert(counter(Counter, NewCount))
	;
	    assert(counter(Counter, 1))).

increaseCounter(Counter, Amount) :-
	(retract(counter(Counter, N))
	->
	    NewCount is N + Amount,
	    assert(counter(Counter, NewCount))
	;
	    assert(counter(Counter, Amount))).

decrementCounter(Counter) :-
	retract(counter(Counter, N)),
	NewCount is N - 1,
	(NewCount > 0
	->
	    assert(counter(Counter, NewCount))
	;
	    true).
