:- multifile h/3.
:- dynamic h/3.
:- retractall(h(_,_,_)).

distance(pos(X1, Y1), pos(X2, Y2), Distance) :-
	XDelta is abs(X1 - X2),
	YDelta is abs(Y1 - Y2),
	Distance is YDelta + XDelta,
	!.

h(State, Goal, HValue) :-
	h(State, Goal, 0, HValue), !.

h([ ], _, HValue, HValue).

h([at(agent, _) | Rest], Goal, OldHValue, HValue) :-
	h(Rest, Goal, OldHValue, HValue).

h([at(box(Id), Pos1) | Rest], Goal, OldHValue, HValue) :-
	member(at(box(Id), Pos2), Goal),
	distance(Pos1, Pos2, Distance),
	NewHValue is OldHValue + Distance,
	h(Rest, Goal, NewHValue, HValue).

h([Term | Rest], Goal, OldHValue, HValue) :-
	Term \= at(agent, _),
	Term \= at(box, _),
	h(Rest, Goal, OldHValue, HValue).