%	$Id: ops.pl,v 1.3 2008/10/30 01:34:59 mbar098 Exp mbar098 $	
:- multifile op/4.
:- dynamic op/4.

/*
3 operators:
=============
- move(Pos1, Pos2) agent moves from Pos1 to Pos2
- push(Pos1, Pos2, Box, Pos3) agent at Pos1 pushes Box from Pos2 to
                              Pos3 
- load(Pos1, Pos2, Box, Pos3) agent at Pos1 pushes Box from Pos2 onto
                        elevator at Pos3
*/

op(load, [Pos1, Pos2, Box, Pos3],
   [elevatorAt(Pos3), at(Box, Pos2), nextTo(Pos2, Pos3),
    at(agent, Pos1), between(Pos2, Pos1, Pos3)],
   [at(agent, Pos2), not(at(agent, Pos1)),
    at(Box, Pos3), not(at(Box, Pos2))]).

op(push, [Pos1, Pos2, Box, Pos3],
   [at(agent, Pos1), at(Box, Pos2),
    between(Pos2, Pos1, Pos3), clear(Pos3),
    safe(Pos3), not(elevatorAt(Pos3))],
   [at(agent, Pos2), not(at(agent, Pos1)),
    at(Box, Pos3), not(at(Box, Pos2))]).

op(move, [Pos1, Pos2],
   [at(agent, Pos1), nextTo(Pos1, Pos2), clear(Pos2)],
   [at(agent, Pos2), not(at(agent, Pos1))]).


/* all operators cost 1 */
cost(_, _, 1).  